	SuperStrict
	
	Import brl.retro
	Import brl.system
	
	
	Private
	
	Global paramchars$="~~~q` /\.!@#$%^&*()[]{}|:'_-+1234567890qwertyuiopasdfghjklzxcvbnmQWERTYUIOPASDFGHJKLZXCVBNM;"
	Global paramquantity@=10

	Function ResetParams()
		numparams=0
		For Local reset%=0 To paramquantity-1
			param[reset]=""
		Next
	End Function
	Function CleanParams()
		For Local clean%=0 To numparams-1
			param[clean]=Replace(param[clean],Chr(9)," ") 'tab
			param[clean]=Replace(param[clean],Chr(34)," ")'return
			param[clean]=Trim(param[clean])
		Next
	End Function
	

	Public
	
	Global param$[paramquantity],numparams@
	Global comment$="//"
	
	Function Parse$(line$,disp$="")
		line=Trim(Replace(line,Chr(9)," "))
		Local name$=""
		If Left(Trim(line),Len(comment))=comment Then CleanParams;Return ""
		ResetParams()
		Local pos@@=0,onparam%=-1
		Repeat
			pos:+1
			Local char$=Mid(line,pos,1)
			If char=" " And onparam=-1 Then onparam=0;numparams=1;char=""
			If char="," Then onparam:+1;numparams:+1;char=""
			If onparam>paramquantity-1 Then Exit
			If Instr(line,comment)=pos Then Exit
			If Instr(paramchars,char) Then
				If onparam=-1
					If Not(char=" " Or char="~q") Then name:+char
				Else
					If char="~q" Then 'if it's in quotes, then anything goes in a param.
						Repeat
							pos:+1
							char=Mid(line,pos,1)
							If char="~q" Then Exit
							param[onparam]:+char
						Until pos>Len(line)
						If pos>Len(line) Then CleanParams;Notify "Improperly teminated string "+disp+" ( "+param[onparam]+" )",1;Return name
					Else
						param[onparam]:+char
					EndIf
				EndIf
			EndIf
		Until pos>Len(line)
		CleanParams
		If numparams=1
			If param[numparams-1]="" numparams:-1
		EndIf
		Return Trim(name)
	End Function

