SuperStrict



Framework brl.standardio
Import brl.system
Import brl.random
Import "graphics.bmx"



SeedRnd MilliSecs()

initgraphics "data\graphics.txt"


Global map:tilemap=tilemap.Create(32,32)
map.fill 0,WHITE,BLACK
Global mines%[32,32]
Global mask:tilemap=tilemap.Create(32,32)
mask.fill 249,8,1

Function genmap(nummines%)
	lost=0;canedit=1
	mask.fill 249,8,1
	Local minesl:TList=CreateList()
	For Local gen%=1 To nummines
		Local this:vector=vector.Create(Rand(0,31),Rand(0,31))
		Local check%=1
		While check And minesl.count()
			check=0
			For Local that:vector=EachIn minesl
				If that<>this And that.x=this.x And that.y=this.y Then
					check=1
					this.x=Rand(0,31)
					this.y=Rand(0,31)
				EndIf
			Next
		Wend
		minesl.addlast this
	Next
	Local count%=0,here%=0
	For Local dox%=0 To 31
	For Local doy%=0 To 31
		count=0;here=0
		For Local kx%=-1 To 1
		For Local ky%=-1 To 1
			For Local this:vector=EachIn minesl
				If this.x=dox+kx And this.y=doy+ky
					count:+1
					If kx=0 And ky=0 Then here=1
				EndIf
			Next
		Next
		Next
		If here Then 
			map.settile dox,doy,42,48,26
		ElseIf count
			Local clr@=0
			Select count
				Case 1 clr=45
				Case 2 clr=28
				Case 3 clr=41
				Case 4 clr=42
				Case 5 clr=15
				Case 6 clr=10
				Case 7 clr=26
				Case 8 clr=2
			End Select
			map.settile dox,doy,Asc(String(count)),clr,8
		Else
			map.settile dox,doy,249,1,8
		EndIf
	Next
	Next
	starttime=MilliSecs()
End Function




Global help:tilemap=tilemap.Create(16,8)
help.fill 0,LYELLOW,DBLUE
help.insertstring 0,0,"    ==HELP==    ",LYELLOW,DBLUE
help.insertstring 0,2,"Left click to sh",LYELLOW,DBLUE
help.insertstring 0,3,"ow a tile. Right",LYELLOW,DBLUE
help.insertstring 0,4,"click to flag it",LYELLOW,DBLUE
help.insertstring 0,5,"Lose by clicking",LYELLOW,DBLUE
help.insertstring 0,6,"a mine. To win, ",LYELLOW,DBLUE
help.insertstring 0,7,"reveal all else.",LYELLOW,DBLUE
Global showhelp%=0

Global loser:tilemap=tilemap.Create(32,1)
loser.fill 0,LYELLOW,DBLUE
loser.insertstring 0,0,"You lose! Press R to start again",LYELLOW,DBLUE

Global winner:tilemap=tilemap.Create(32,1)
winner.fill 0,LYELLOW,DBLUE
winner.insertstring 0,0,"You win! Press R to start again.",LYELLOW,DBLUE

Global hud:tilemap=tilemap.Create(36,36)
hud.fill 0,LYELLOW,BCYAN
hud.settiles 2,3,32,32,0,BLACK,BLACK
hud.settiles 0,0,36,3,0,BLACK,BLACK
hud.insertstring 2,2,"Time elapsed: ",LYELLOW,BLACK


Global canedit%=1,lost%=0,flipped%=0,inmines%=64,blink%=0,won%=0,lastmsg%=-1
genmap inmines

Global starttime%,gottime%=0,time%=0

Global helpmsg:TList=CreateList()
'               "................................" ....... "................................"
helpmsg.addlast "Start a new round by pressing R."+NEWLINE+"                                "
helpmsg.addlast "Set the number of stars with M. "+NEWLINE+"                                "
helpmsg.addlast "Flag where you think a mine is  "+NEWLINE+"by right clicking there.        "
helpmsg.addlast "*Sweeper was written in BlitzMax"+NEWLINE+"by David Kirschner.             "
helpmsg.addlast "Did you know? *Sweeper is just a"+NEWLINE+"blatant ripoff of Minesweeper.  "
helpmsg.addlast "Win by uncovering everything    "+NEWLINE+"that's not a star.              "
helpmsg.addlast "You lose if you reveal a star.  "+NEWLINE+"                                "
helpmsg.addlast "You can do it, I believe in you!"+NEWLINE+"                                "

Repeat
	Cls
	If blink Mod 512=0 Then
		Local choose%=Rand(0,helpmsg.count()-1)
		While choose=lastmsg
			choose%=Rand(0,helpmsg.count()-1)
		Wend
		lastmsg=choose
		For Local find$=EachIn helpmsg
			If choose=0
				hud.insertstring 2,0,find,YELLOW,BLACK
				Exit
			EndIf
			choose:-1
		Next
	EndIf
	blink:+1
	updatemouse
	Local ax%=mx-2,ay%=my-3
	time%=MilliSecs()-starttime
	If flipped=0 Then time=-1;starttime=MilliSecs()
	If ax=>0 And ax<32 And ay=>0 And ay<32 And (canedit Or flipped=0) And Not showhelp
		If lmbu Then
			mask.settile ax,ay,255,255,255,1
			Local getc@,getf@,getb@
			map.grabtile ax,ay,getc,getf,getb
			flipped:+1
			If getc=249 Then '0
				flipped:+map.floodfill(mask,ax,ay,255,255,255,1,1,1)-1
			ElseIf getc=42 'mine
				canedit=0
				gottime=time
				lost=1
				For Local findx%=0 To 31
				For Local findy%=0 To 31
					Local getc2@,getf2@,getb2@
					map.grabtile findx,findy,getc2,getf2,getb2
					If getc2=Asc("*") Then mask.settile findx,findy,255,255,255,1
				Next
				Next
			Else 'number
				
			EndIf
		ElseIf rmbu Then
			Local getc@,getf@,getb@
			mask.grabtile ax,ay,getc,getf,getb
			If getc=159
				mask.settile ax,ay,249,8,1
			ElseIf getc=249
				mask.settile ax,ay,159,10,1
			EndIf
		EndIf
	EndIf
	If KeyHit(key_m) Then
		inmines=Int(cin("# of mines: "))
		If inmines<1 inmines=1
		If inmines>32*32-1 inmines=32*32-1
		genmap inmines
	EndIf
	If flipped=32*32-inmines And Not lost Then won=1
	If canedit=0 Then time=gottime
	If time>0
		hud.insertstring 16,2,((time/1000)/60)+"m "+((time/1000) Mod 60)+"s    ",LYELLOW,BLACK
	Else
		hud.insertstring 16,2,"--m --s    ",LYELLOW,BLACK
	EndIf
	hud.draw 0,0
	If KeyHit(key_r) Then genmap inmines
	If lost And blink Mod 80<40 Then loser.draw 2,1
	If won And blink Mod 80<40 Then winner.draw 2,1
	map.draw 2,3
	mask.draw 2,3
	If KeyHit(key_f1) showhelp=Not showhelp
	If showhelp help.draw 10,15
	Flip
	If AppTerminate() Then End
Forever

